<?php

namespace Alive\Dm;

class Discounts_Shortcut extends Short_Code {

    const DEFAULT_LIMIT = 10;

    /**
     * (non-PHPdoc)
     * @see \Alive\Dm\Short_Code::load_scripts()
     */
    public function load_scripts() {
        wp_enqueue_style("discount-search",
            plugins_url("resources/alive-dm/css/discount_search.css",
                dirname(__FILE__))
        );
        // Include javascripts.
        wp_enqueue_script('jquery');
        wp_enqueue_script("alive-dm-plugin-discount-shortcut",
            plugins_url("resources/alive-dm/js/discount_shortcut.js",
                dirname(__FILE__)),
            array()
        );
    }

    /**
     * (non-PHPdoc)
     * @see \Alive\Dm\Short_Code::short_code()
     */
    protected function short_code() {
        return 'dm_searchbox';
    }

    /**
     * (non-PHPdoc)
     * @see \Alive\Dm\Short_Code::handler()
     */
    public function handler($attributes) {
        return $this->render($attributes['url']);
    }

    /**
     * Render the plugin HTMl.
     * @param unknown $discount_search_url URL of the discount search.
     */
    private function render($discount_search_url) {
        // Keep query of the provided url.
        $queryParams = array();
        parse_str(parse_url($discount_search_url, PHP_URL_QUERY), $queryParams);
        $hiddenQuery = '';
        if (!empty($queryParams)) {
            foreach ($queryParams as $name => $value) {
                $hiddenQuery .= '<input type="hidden" name="' . $name . '" value="' . $value . '" />';
            }
        }
        $data = [
            'discount_search_url' => $discount_search_url,
            'ajax_url' => admin_url('admin-ajax.php'),
            'queryParams' => $queryParams,
        ];
        $template = new Template('discount-search.phtml', $data);
        return $template->build();
    }

}
